// VISensor.h: interface of the CVISensor class
//
/*--------------------------------------------------------------------------*/
/*       Copyright(C) 2004-2008 KONICA MINOLTA SENSING,INC.                 */
/*--------------------------------------------------------------------------*/

#if !defined(__VISENSOR_H__)
#define __VISENSOR_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef HARDWARE_EXPORTS
#define HARDWARE_API __declspec(dllexport)
#else
#define HARDWARE_API __declspec(dllimport)
#endif

#include "VISensorPara.h"
#include "VividObject.h"
#include "VISensorInitPara.h"
#include <VIVertexData.h>
#include "VISensorRawData.h"
#include "VISensorImportPara.h"
#include <VividImageData.h>

#include <VISensorCalibErr.h>
#include <VISensorCalibInfo.h>
class CVISensorBase;
class HARDWARE_API CVISensor  
{
public:
    virtual BOOL GetRawData(CVISensorRawData *pRawData);
    virtual BOOL GetVvdImageData(CVvdImage& VvdImage,int DataLabel,CVISensorImportPara* pImportPara);
	virtual BOOL ChangeColorData(void);
	virtual BOOL Focus(void);
	virtual BOOL Calibrate(CVISensorCalibErr* pCalibErr = NULL);
	virtual BOOL Init(CVISensorInitPara* pInitPara = NULL);
	virtual BOOL CheckConnection(void);
	virtual BOOL Ready(void);
	virtual BOOL Measure(void);
	virtual BOOL SetSensorPara(CVISensorPara* pSensorPara);
	virtual BOOL GetSensorPara(CVISensorPara* pSensorPara);
	virtual BOOL GetErrCode(int& nErrCode);
	virtual void SetErrCode(int  nErrCode);
   	virtual BOOL GetPolygonData(CVIObject& Polygon,CVISensorImportPara* pImportPara = NULL,LPCTSTR name = NULL); // const char* -> LPCTSTR    virtual BOOL GetVertexData(CVIVertexData* pVertexData,CVISensorImportPara* pImportPara= NULL);
    virtual BOOL GetVertexData(CVIVertexData* pVertexData,CVISensorImportPara* pImportPara= NULL);
	virtual BOOL SaveRawData(LPCTSTR filename); // const char* -> LPCTSTR
	virtual BOOL GetCalibrationInfo(CVISensorCalibInfo *pCalibInfo);
	virtual BOOL SetId(BYTE byId);
	virtual BYTE GetId(void);
	CVISensor();
	virtual ~CVISensor();
protected:
	CVISensorBase* m_pSensorBase;
};

#endif
