// Vivid9iPara.h: interface of the CVivid9iPara class
/*--------------------------------------------------------------------------*/
/*       Copyright(C) 2004-2008 KONICA MINOLTA SENSING,INC.                 */
/*--------------------------------------------------------------------------*/

#if !defined(__VIVID9IPARA_H__)
#define __VIVID9IPARA_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef HARDWARE_EXPORTS
#define HARDWARE_API __declspec(dllexport)
#else
#define HARDWARE_API __declspec(dllimport)
#endif


#include "VISensorPara.h"
const int VI9I_COLOR_WIDTH   = 640;
const int VI9I_COLOR_HEIGHT  = 480;
const int VI9I_PITCH_WIDTH   = 640;
const int VI9I_PITCH_HEIGHT  = 480;
const int VI9I_MONITOR_WIDTH   = 640;
const int VI9I_MONITOR_HEIGHT  = 480;

#define  VI9I_DM_STANDARD		0
#define  VI9I_DM_EXTEND         1
#define  VI9I_DM_USER			2

#define VI9I_RM_FINE            1

#define VI9I_AUTOREAD_ON    1
#define VI9I_AUTOREAD_OFF   0

#define VI9I_LENS_WIDE      0
#define VI9I_LENS_MIDDLE    1
#define VI9I_LENS_TELE      2


class HARDWARE_API CVivid9iPara : public CVISensorPara  
{
public:
    BYTE    m_byDigitizeMode;
    BOOL    m_bActAF        ;
    BOOL    m_bActAE        ;
    BOOL    m_bColorAE      ;
    BOOL    m_bLog          ;
    BOOL    m_bDark         ;
    WORD    m_wDistance     ;
    WORD    m_wMaxDistance  ;
    WORD    m_wMinDistance  ;
    BYTE    m_byLdPower     ;
    BYTE    m_byGain        ;
    BYTE    m_byReleaseMode ;
    BYTE    m_byColorLevel  ;
    BOOL    m_bColor        ;   // (TRUE:use, FALSE:no use)
    BYTE    m_byReserve1    ;
    BYTE    m_byScanNum     ;   // Number of sacan per 1shot
    BYTE    m_byHighQuality ;   // HighQuality On/OFF
    BYTE    m_byNoiseFilter	;   // Noisefilter On/OFF
    CHAR    m_cSerialNumber[8];
    BYTE    m_byLensType    ;   // Lens Type(0:Wide,1:Middle,2:Tele)
    BYTE    m_byColorLevelStep ;
    BYTE    m_byMaxLdPower     ;
    BYTE    m_byGainStep       ;
    CHAR    m_cVersionNumber[8];

    CVivid9iPara();
	virtual ~CVivid9iPara();
};

#endif
