// VividImportPara.h: interface of the CVividImportPara class
//
/*--------------------------------------------------------------------------*/
/*       Copyright(C) 2004-2008 KONICA MINOLTA SENSING,INC.                 */
/*--------------------------------------------------------------------------*/

#if !defined(__VIVIDIMPORTPARA_H__)
#define __VIVIDIMPORTPARA_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifdef DATAPROCESS_EXPORTS
#define DATAPROCESS_API __declspec(dllexport)
#else
#define DATAPROCESS_API __declspec(dllimport)
#endif

#include "VISensorImportPara.h"

enum VIReduceMode       { VIReduceNone = 1,VIReduce1_4,VIReduce1_9,VIReduce1_16,VIReduceAdaptive}   ;   
enum VIFilterMode       { VINoneFilter=0,VINoiseFilter ,VIHighQuality  ,VINoiseFilterHighQuality}   ;
enum VICutDataMode      { VINoneCut,VIBoundaryCut,VIDeg5Cut,VIDeg10Cut,VIDeg15Cut,VIDeg20Cut}       ;
enum VIFillHolesMode    { VIFillOff,VIFillOn};

class DATAPROCESS_API CVividImportPara : public CVISensorImportPara  
{
protected:
    void Copy(const CVividImportPara &ImportPara);
public:
	CVividImportPara();
    CVividImportPara(const CVividImportPara &ImportPara);
    CVividImportPara& operator=(const CVividImportPara &ImportPara);
    virtual ~CVividImportPara();
    int		m_nReduce;	// Reduce rate				
    int		m_nFilter;	// Noise Filter
    int		m_nCutData;	// Cut Data@
    int		m_nFillHole;// Fill Holes
    BOOL    m_bDark;	// Color Dark Correction
    BOOL    m_bLog;		// Color Log Correction

	int		m_nDirection;	// SEEDS@060608 0 cu 1 u

};

#endif
