/*--------------------------------------------------------------------------*/
/*       Copyright(C) 2004-2008 KONICA MINOLTA SENSING,INC.                 */
/*--------------------------------------------------------------------------*/
// VIDataProcessSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VIDataProcessSample.h"
#include "VIDataProcessSampleDlg.h"
#include ".\vidataprocesssampledlg.h"

#include "VI9iDataProcessControl.h"
#include <VvdImage.h>
#include <Vivid9iErrCode.h>
#include <VividObject.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CVIDataProcessSampleDlg dialog



CVIDataProcessSampleDlg::CVIDataProcessSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVIDataProcessSampleDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_pVI9iDataProcessCtrl = NULL;
}

CVIDataProcessSampleDlg::~CVIDataProcessSampleDlg()
{
    delete m_pVI9iDataProcessCtrl;
}


void CVIDataProcessSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CVIDataProcessSampleDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
    ON_BN_CLICKED(IDC_BUTTON_IMPORT_SAVEPOLYGON, OnBnClickedButtonImportSavepolygon)
    ON_BN_CLICKED(IDC_BUTTON_IMPORT_SAVE_ASCII, OnBnClickedButtonImportSaveAscii)
    ON_BN_CLICKED(IDC_BUTTON_READ_POLYGON, OnBnClickedButtonReadPolygon)
    ON_BN_CLICKED(IDC_BUTTON_GET_COLOR_DATA, OnBnClickedButtonGetColorData)
    ON_BN_CLICKED(IDC_BUTTON_GET_REFLECT_DATA, OnBnClickedButtonGetReflectData)
END_MESSAGE_MAP()


// CVIDataProcessSampleDlg message handlers

BOOL CVIDataProcessSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
    m_pVI9iDataProcessCtrl = new CVI9iDataProcessControl;
    ViewInit();
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVIDataProcessSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
        CPaintDC dc(this);
        DrawPicture(dc);
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVIDataProcessSampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}
//---------------------------------------------------------------------------------------//
// Attention! Only support 32-bit true color 
void CVIDataProcessSampleDlg::DrawPicture(CPaintDC &dc)
{

    CDC* pDc = &dc;

    int width, height, memory_size;

    CDC dcNew;
    dcNew.CreateCompatibleDC(pDc);

    m_VvdImage.GetSize( width, height);
    CBitmap     bitmap    ;
    BOOL bSuccess = bitmap.CreateCompatibleBitmap(pDc, width , height );
    if (!bSuccess)  return;

    memory_size = width * height * sizeof(RGBQUAD);

    RGBQUAD* pRGB = (RGBQUAD*)m_VvdImage.m_pImage;
    bitmap.SetBitmapBits( memory_size, pRGB);
    dcNew.SelectObject(bitmap);

    pDc->SetStretchBltMode(HALFTONE);
    SetBrushOrgEx(pDc->m_hDC, 0, 0, NULL);
    pDc->StretchBlt( m_DstRect.left, m_DstRect.top, 
                                m_DstRect.Width(),
                                m_DstRect.Height(),
                                  &dcNew, 0, 0, width, height, SRCCOPY );

    dcNew.DeleteDC();

}
//---------------------------------------------------------------------------------------//
void CVIDataProcessSampleDlg::ViewInit(void)
{
    CRect rectView;
    CWnd* pWnd;
    pWnd = GetDlgItem(IDC_STATIC_PREVIEW);
    pWnd->GetWindowRect(m_DstRect);
    ScreenToClient(m_DstRect);
}

//---------------------------------------------------------------------------------------//
//Show Last Error Message
void CVIDataProcessSampleDlg::ShowLastErr(void)
{
    int nErrCode;
    nErrCode = m_pVI9iDataProcessCtrl->GetErrCode();

    switch( nErrCode )
    {
    case VI_ERR_NONE:
        break;
    case VI_ERR_NOT_CONNECT:
        AfxMessageBox( _T("VIVID not found."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_OUT_OF_DISTANCE:
        AfxMessageBox(_T("Out of distance."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_CANT_READY:
        AfxMessageBox(_T("AF error. Laser barrier may be closed."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_MEASURE:
        AfxMessageBox(_T("Measure Error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_AF_DRIVING:
        AfxMessageBox(_T("AF Motor Driving."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_MEMORY_WRITE:
        AfxMessageBox(_T("SCSI write error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_MEMORY_READ:
        AfxMessageBox(_T("SCSI read error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_POWER_RESET:
        AfxMessageBox(_T("Porwer On Reset Occured."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_HARDWARE_ANY:
        AfxMessageBox(_T("Something wrong with VIVID."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_MEM_ALLOC:
        AfxMessageBox(_T("Memory allocation error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_FILE_WRITE:
        AfxMessageBox(_T("File write error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_FILE_READ:
        AfxMessageBox(_T("File read error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_NO_DATA:
        AfxMessageBox(_T("There are no points."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_ILLEGAL_FILE:
        AfxMessageBox(_T("Illegal format file."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_NOT_READY_REMOTE:
        AfxMessageBox(_T("Not Ready for Remote."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_CHART_MEASURE:
        AfxMessageBox(_T("Field Calibration : Scan Error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_CHART_EVALUATE:
        AfxMessageBox(_T("Field Calibration : Evaluate Error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_CHART_CALIBRATE:
        AfxMessageBox(_T("Field Calibration : Calibrate Error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_STAGE_REGIST:
        AfxMessageBox(_T("Please capture chart data again."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_ILLEGAL_PARAM:
        AfxMessageBox(_T("Illegal parameter ."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_NO_IMAGE_DATA:
        AfxMessageBox(_T("No image data."), MB_OK | MB_ICONERROR );
        break;
    default:
        AfxMessageBox(_T("Something wrong with VIVID."), MB_OK | MB_ICONERROR );
    }
}

//---------------------------------------------------------------------------------------//
void CVIDataProcessSampleDlg::OnBnClickedButtonImportSavepolygon()
{
    CWaitCursor waitcursor;
    BOOL bSuccess;
    bSuccess = m_pVI9iDataProcessCtrl->SavePolygonFile();
    if (!bSuccess)
    {
        ShowLastErr();
        return;
    }
}
//---------------------------------------------------------------------------------------//
void CVIDataProcessSampleDlg::OnBnClickedButtonImportSaveAscii()
{
    CWaitCursor waitcursor;
    BOOL bSuccess;
    bSuccess = m_pVI9iDataProcessCtrl->SaveASCIIData();
    if (!bSuccess)
    {
        ShowLastErr();
        return;
    }
}

//---------------------------------------------------------------------------------------//
void CVIDataProcessSampleDlg::OnBnClickedButtonReadPolygon()
{
    CWaitCursor waitcursor;
    BOOL bSuccess;
    CVIObject PolygonData;
    bSuccess = m_pVI9iDataProcessCtrl->ReadPolygonFile(PolygonData);
    if (!bSuccess)
    {
        ShowLastErr();
        return;
    }
}
//---------------------------------------------------------------------------------------//
void CVIDataProcessSampleDlg::OnBnClickedButtonGetColorData()
{
    CWaitCursor waitcursor;
    CVvdImage ColorImage;
    BOOL bSuccess;
    bSuccess = m_pVI9iDataProcessCtrl->GetColorData(ColorImage,TRUE,TRUE);
    if (!bSuccess)
    {
        ShowLastErr();
        return;
    }
    m_VvdImage = ColorImage;
    RedrawWindow();
}

//---------------------------------------------------------------------------------------//
void CVIDataProcessSampleDlg::OnBnClickedButtonGetReflectData()
{
    CWaitCursor waitcursor;
    CVvdImage ReflectImage;
    BOOL bSuccess;
    bSuccess = m_pVI9iDataProcessCtrl->GetReflectData(ReflectImage);
    if (!bSuccess)
    {
        ShowLastErr();
        return;
    }
    m_VvdImage = ReflectImage;
    RedrawWindow();
}
