/*--------------------------------------------------------------------------*/
/*       Copyright(C) 2004-2008 KONICA MINOLTA SENSING,INC.                 */
/*--------------------------------------------------------------------------*/
// VIHardwareSampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VIHardwareSample.h"
#include "VIHardwareSampleDlg.h"
#include ".\vihardwaresampledlg.h"
#include "Vivid9iControl.h"
#include <VvdImage.h>
#include <Vivid9iErrCode.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CVIHardwareSampleDlg dialog



CVIHardwareSampleDlg::CVIHardwareSampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVIHardwareSampleDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_pVivid9iControl = NULL;
}
//---------------------------------------------------------------------------------------//
CVIHardwareSampleDlg::~CVIHardwareSampleDlg()
{
    delete m_pVivid9iControl;
}

//---------------------------------------------------------------------------------------//
void CVIHardwareSampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CVIHardwareSampleDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
    ON_BN_CLICKED(IDC_BUTTON_SAVE_RAWDATA, OnBnClickedButtonSaveRawdata)
    ON_BN_CLICKED(IDC_BUTTON_SAVE_POLYGON, OnBnClickedButtonSavePolygon)
    ON_BN_CLICKED(IDC_BUTTON_SAVE_ASCII, OnBnClickedButtonSaveAscii)
    ON_BN_CLICKED(IDC_BUTTON_GET_MONITOR, OnBnClickedButtonGetMonitor)
    ON_BN_CLICKED(IDC_BUTTON_GET_COLOR_DATA, OnBnClickedButtonGetColorData)
    ON_BN_CLICKED(IDC_BUTTON_CALIBRATION, OnBnClickedButtonCalibration)
	ON_CBN_SELCHANGE(IDC_COMBO_VIVID, &CVIHardwareSampleDlg::OnSelChangeComboVivid)
END_MESSAGE_MAP()


// CVIHardwareSampleDlg message handlers

//---------------------------------------------------------------------------------------//
BOOL CVIHardwareSampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
    m_pVivid9iControl = new CVivid9iControl;
    ViewInit();

	// SEEDS@071009
	CComboBox* pCombo = (CComboBox*)GetDlgItem(IDC_COMBO_VIVID);
	pCombo->InsertString(0, _T("VIVID9i"));
	pCombo->InsertString(1, _T("VIVID910"));

	if( !ConnectToVivid(VI_VIVID9i_SENSOR) ) {
		ShowLastErr();
	}
	pCombo->SetCurSel(0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

//---------------------------------------------------------------------------------------//
void CVIHardwareSampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

//---------------------------------------------------------------------------------------//
void CVIHardwareSampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
        CPaintDC dc(this);
        DrawPicture(dc);
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
//---------------------------------------------------------------------------------------//
HCURSOR CVIHardwareSampleDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


//---------------------------------------------------------------------------------------//
void CVIHardwareSampleDlg::ShowLastErr(void)
{
    int nErrCode;
    nErrCode = m_pVivid9iControl->GetErrCode();

    switch( nErrCode )
    {
    case VI_ERR_NONE:
        break;
    case VI_ERR_NOT_CONNECT:
        AfxMessageBox( _T("VIVID not found."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_OUT_OF_DISTANCE:
        AfxMessageBox(_T("Out of distance."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_CANT_READY:
        AfxMessageBox(_T("AF error. Laser barrier may be closed."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_MEASURE:
        AfxMessageBox(_T("Measure Error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_AF_DRIVING:
        AfxMessageBox(_T("AF Motor Driving."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_MEMORY_WRITE:
        AfxMessageBox(_T("SCSI write error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_MEMORY_READ:
        AfxMessageBox(_T("SCSI read error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_POWER_RESET:
        AfxMessageBox(_T("Porwer On Reset Occured."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_HARDWARE_ANY:
        AfxMessageBox(_T("Something wrong with VIVID."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_MEM_ALLOC:
        AfxMessageBox(_T("Memory allocation error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_FILE_WRITE:
        AfxMessageBox(_T("File write error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_FILE_READ:
        AfxMessageBox(_T("File read error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_NO_DATA:
        AfxMessageBox(_T("There are no points."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_ILLEGAL_FILE:
        AfxMessageBox(_T("Illegal format file."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_NOT_READY_REMOTE:
        AfxMessageBox(_T("Not Ready for Remote."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_CHART_MEASURE:
        AfxMessageBox(_T("Field Calibration : Scan Error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_CHART_EVALUATE:
        AfxMessageBox(_T("Field Calibration : Evaluate Error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_CHART_CALIBRATE:
        AfxMessageBox(_T("Field Calibration : Calibrate Error."), MB_OK | MB_ICONERROR );
        break;
    case VI_ERR_STAGE_REGIST:
        AfxMessageBox(_T("Please capture chart data again."), MB_OK | MB_ICONERROR );
        break;
    default:
        AfxMessageBox(_T("Something wrong with VIVID."), MB_OK | MB_ICONERROR );
    }

}

//---------------------------------------------------------------------------------------//
void CVIHardwareSampleDlg::OnBnClickedButtonSaveRawdata()
{
    CWaitCursor waitcursor;
    BOOL bSuccess;
    bSuccess = m_pVivid9iControl->DoScan();
    if (!bSuccess)
    {
        ShowLastErr();
        return;
    }
    bSuccess = m_pVivid9iControl->SaveRawData();
    if (!bSuccess)  ShowLastErr();
}

//---------------------------------------------------------------------------------------//
void CVIHardwareSampleDlg::OnBnClickedButtonSavePolygon()
{
    CWaitCursor waitcursor;
    BOOL bSuccess;
    bSuccess = m_pVivid9iControl->DoScan();
    if (!bSuccess)
    {
        ShowLastErr();
        return;
    }
    bSuccess = m_pVivid9iControl->SavePolygonData();
    if (!bSuccess)  ShowLastErr();
}

//---------------------------------------------------------------------------------------//
void CVIHardwareSampleDlg::OnBnClickedButtonSaveAscii()
{
    CWaitCursor waitcursor;
    BOOL bSuccess;
    bSuccess = m_pVivid9iControl->DoScan();
    if (!bSuccess)
    {
        ShowLastErr();
        return;
    }
    bSuccess = m_pVivid9iControl->SaveASCIIData();
    if (!bSuccess)  ShowLastErr();
}


//---------------------------------------------------------------------------------------//
void CVIHardwareSampleDlg::OnBnClickedButtonGetMonitor()
{
    CVvdImage MonitorImage;
    BOOL bSuccess;
    bSuccess = m_pVivid9iControl->GetMonitorData(MonitorImage,TRUE,TRUE);
    if (!bSuccess)
    {
        ShowLastErr();
        return;
    }
    m_VvdImage = MonitorImage;
    RedrawWindow();
}

//---------------------------------------------------------------------------------------//
void CVIHardwareSampleDlg::OnBnClickedButtonGetColorData()
{
    CWaitCursor waitcursor;
    CVvdImage ColorImage;
    BOOL bSuccess;
    bSuccess = m_pVivid9iControl->GetColorData(ColorImage,TRUE,TRUE);
    if (!bSuccess)
    {
        ShowLastErr();
        return;
    }
    m_VvdImage = ColorImage;
    RedrawWindow();
}

//---------------------------------------------------------------------------------------//
// Attention! Only support 32-bit true color 
void CVIHardwareSampleDlg::DrawPicture(CPaintDC &dc)
{

    CDC* pDc = &dc;

    int width, height, memory_size;

    CDC dcNew;
    dcNew.CreateCompatibleDC(pDc);

    m_VvdImage.GetSize( width, height);
    CBitmap     bitmap    ;
    BOOL bSuccess = bitmap.CreateCompatibleBitmap(pDc, width , height );
    if (!bSuccess)  return;

    memory_size = width * height * sizeof(RGBQUAD);

    RGBQUAD* pRGB = (RGBQUAD*)m_VvdImage.m_pImage;
    bitmap.SetBitmapBits( memory_size, pRGB);
    dcNew.SelectObject(bitmap);

    pDc->SetStretchBltMode(HALFTONE);
    SetBrushOrgEx(pDc->m_hDC, 0, 0, NULL);
    pDc->StretchBlt( m_DstRect.left, m_DstRect.top, 
                                m_DstRect.Width(),
                                m_DstRect.Height(),
                                  &dcNew, 0, 0, width, height, SRCCOPY );

    dcNew.DeleteDC();

}

//---------------------------------------------------------------------------------------//
void CVIHardwareSampleDlg::ViewInit(void)
{
    CRect rectView;
    CWnd* pWnd;
    pWnd = GetDlgItem(IDC_STATIC_PREVIEW);
    pWnd->GetWindowRect(m_DstRect);
    ScreenToClient(m_DstRect);
}

//---------------------------------------------------------------------------------------//
void CVIHardwareSampleDlg::OnBnClickedButtonCalibration()
{
    CWaitCursor waitcursor;

    BOOL bSuccess;
    bSuccess = m_pVivid9iControl->DoCalibration();
    if (!bSuccess)
    {
        ShowLastErr();
        return;
    }
}

void CVIHardwareSampleDlg::OnSelChangeComboVivid()
{
	CComboBox* pCombo = (CComboBox*)GetDlgItem(IDC_COMBO_VIVID);
	int nVividType = -1;
	switch( pCombo->GetCurSel() ) {
		case 0:
			nVividType = VI_VIVID9i_SENSOR;
			break;
		case 1:
			nVividType = VI_VIVID910_SENSOR;
			break;
		default:
			return;
			break;
	}
	CWaitCursor waitcursor;
	BOOL bSuccess = ConnectToVivid(nVividType);

    if (!bSuccess)
    {
        ShowLastErr();
        return;
    }
}

BOOL CVIHardwareSampleDlg::ConnectToVivid(int nVividType)
{
	BOOL bSuccess = m_pVivid9iControl->SetVividType( nVividType );

	((CButton*)GetDlgItem(IDC_BUTTON_SAVE_RAWDATA))->EnableWindow(bSuccess);
	((CButton*)GetDlgItem(IDC_BUTTON_SAVE_POLYGON))->EnableWindow(bSuccess);
	((CButton*)GetDlgItem(IDC_BUTTON_SAVE_ASCII))->EnableWindow(bSuccess);
	((CButton*)GetDlgItem(IDC_BUTTON_GET_COLOR_DATA))->EnableWindow(bSuccess);
	((CButton*)GetDlgItem(IDC_BUTTON_GET_MONITOR))->EnableWindow(bSuccess);
	((CButton*)GetDlgItem(IDC_BUTTON_CALIBRATION))->EnableWindow(bSuccess && nVividType ==VI_VIVID9i_SENSOR);

	return bSuccess;
}
