// VISensorRawFileProcess.h: interface of the VISensorRawFileProcess class
//
/*--------------------------------------------------------------------------*/
/*       Copyright(C) 2004-2008 KONICA MINOLTA SENSING,INC.                 */
/*--------------------------------------------------------------------------*/

#if !defined(__VI_SENSOR_RAWFILEPROCESS_H__)
#define __VI_SENSOR_RAWFILEPROCESS_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "VISensorRawData.h"
#include "VISensorRawDataList.h"
#include "VISensorDataProcess.h"
#include "VividImageData.h"
#include "VIVertexDataList.h"

class DATAPROCESS_API CVISensorRawFileProcess  
{
public:
	CVISensorRawFileProcess();
	virtual ~CVISensorRawFileProcess();
	virtual void GetDataNum(int& DataNum);
	virtual BOOL ReadSensorRawData(const char* filename) = 0;
	virtual BOOL GetPolygonList(CVIObjectList* pPolygonList,CVISensorImportPara* pImportPara  = NULL,const char* name = NULL);
	virtual BOOL GetVertexDataList(CVIVertexDataList* pVertexDataList,CVISensorImportPara* pImportPara = NULL);
    virtual BOOL GetVvdImageData(CVvdImage& VvdImage,int DataLabel,int DataNum,CVISensorImportPara* pImportPara);
	virtual BOOL GetRawDataList(CVISensorRawDataList *pRawDataList) = 0;
	virtual BOOL SaveRawDataList(CVISensorRawDataList *pRawDataList,const char* filename) = 0;

	// SEEDS@060530 -> ǉi`[gf[^j
	virtual BOOL GetChartRawData(CVISensorRawData *pRawData);
	// <- SEEDS@060530

protected:  
	virtual BOOL GetVvdImageData(CVISensorRawData* pRawData,CVvdImage& VvdImage,int DataLabel,CVISensorImportPara* pImportPara);
	virtual BOOL SensorColorToVvdImage(CVISensorColorData* pColorData,CVvdImage& VvdImage,CVISensorImportPara* pImportPara);
	virtual BOOL SensorMonoToVvdImage(CVISensorMonoData* pMonoData,CVvdImage& VvdImage,CVISensorImportPara* pImportPara);
	BOOL SetImageToPolygon(CVISensorRawData* pRawData,CVIObject& Polygon,CVISensorImportPara* pImportPara);
	CVISensorDataProcess* m_pDataProcess;
    CVISensorRawDataList*    m_pRawDataList;
    int m_nErrCode;
public:
    virtual BOOL GetErrCode(int& nErrCode);
    virtual void SetErrCode(int nErrCode);
protected:
    virtual BOOL SetDataProcessErrCode(void);
public:
    virtual BOOL GetDefaultImportPara(CVISensorImportPara* pImportPara, int DataNum);
    virtual BOOL GetRawDataInfo(CVISensorRawDataInfo* pRawDataInfo , int DataNum);
};

#endif
