// VITrans.h: interface of the CVITrans class
//
/*--------------------------------------------------------------------------*/
/*       Copyright(C) 2004-2008 KONICA MINOLTA SENSING,INC.                 */
/*--------------------------------------------------------------------------*/

#if !defined(__VITRANS_H__)
#define __VITRANS_H__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include    <vividIItypes.h>
#include "VividObject.h"
#include "VIVertexData.h"
#include "VIMatrix.h"

#ifdef DATAPROCESS_EXPORTS
#define DATAPROCESS_API __declspec(dllexport)
#else
#define DATAPROCESS_API __declspec(dllimport)
#endif

class   DATAPROCESS_API CVITrans  
{
public:
	void RotateMoveModel(CVIModel *mdl, CVIMatrix4& matrix);
	void RotateModel(CVIModel *mdl, CVIMatrix3& matrix);
	void MoveModel(CVIModel *mdl, VICOORD3D& point);
	void RotateMovePoint(VVDII_Point3 *vertex, CVIMatrix4& matrix);
	void RotatePoint(VVDII_Point3 *vertex, CVIMatrix3& matrix);
	void MovePoint(VVDII_Point3 *vertex, VICOORD3D& point);
    void RotateMovePolygon(CVIObject *obj, CVIMatrix4& matrix);
    void RotateMoveVertexData(CVIVertexData *pVertexData ,CVIMatrix4& matrix);

    CVITrans();
	virtual ~CVITrans();
protected:
    void RotateMoveCameraInfo(VICameraInfo* pCameraInfo, CVIMatrix4& matrix);
    void RotateMoveImageInfo(VIImageInfo* pImageInfo, CVIMatrix4& matrix);
};

#endif
